# GroupDocs.Viewer

jQuery plugin that allows to view documents supported by GroupDocs.Viewer. This application allows you to view DOCX, PDF, PPT, XLS, and over 90 document formats without any additional dependencies and view documents as a set of images or HTML5 pages. 

# Getting started

Install using `npm`

`npm i @groupdocs.examples.jquery/viewer`

or 

`yarn add @groupdocs.examples.jquery/viewer`

Add following code within `<body>` tag

```JS
<div id="element"></div>
<script>
    $('#element').viewer({
        applicationPath: 'http://localhost:8080/viewer'
    });
</script>
```

# Note
This plugin is intended to work with following GroupDocs examples:

- [Document viewer](https://github.com/groupdocs-viewer/GroupDocs.Viewer-for-Java-Spring) for Java Spring
- [Document viewer](https://github.com/groupdocs-viewer/GroupDocs.Viewer-for-Java-Dropwizard) for Java Dropwizard
- [Document viewer](https://github.com/groupdocs-viewer/GroupDocs.Viewer-for-.NET-WebForms) for .NET WebForms
- [Document viewer](https://github.com/groupdocs-viewer/GroupDocs.Viewer-for-.NET-MVC) for .NET MVC

# Resources

- **Website:** [www.groupdocs.com](http://www.groupdocs.com)
- **Product Home:** [GroupDocs.Viewer](https://products.groupdocs.com/viewer)
- **Download:** [Download GroupDocs.Viewer](http://downloads.groupdocs.com/viewer)
- **Free Support Forum:** [GroupDocs.Viewer Free Support Forum](https://forum.groupdocs.com/c/viewer)
- **Paid Support Helpdesk:** [GroupDocs.Viewer Paid Support Helpdesk](https://helpdesk.groupdocs.com)
- **Blog:** [GroupDocs.Viewer Blog](https://blog.groupdocs.com/category/groupdocs-viewer-product-family/)